# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
try:
	from urllib import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
from xml.dom.minidom import parseString
import re
import cntv

def httpget(url):
	try:
		file = urlopen(url)
		content = file.read()
		file.close()
		return content
	except:
		print url
		print 'captured'
		return False

def item(title, url, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode({'url': url}), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	url = 'http://ims.tian-le.com/cntv.php'
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误000')
		sys.exit(0)
	try:
		dom = parseString(content)
	except:
		xbmcgui.Dialog().ok('错误', '错误001')
		sys.exit(0)
	item('cctv', 'cctv', True)
	item('wstv', 'wstv', True)
	for element in dom.getElementsByTagName('item'):
		title = element.getElementsByTagName('title')[0].firstChild.nodeValue
		url = element.getElementsByTagName('url')[0].firstChild.nodeValue
		o = urlparse(url)
		p = o.path.split('/')
		q = parse_qs(o.query)
		l = len(p)
		if o.netloc == 'tv.cctv.com' and p[-1][:4] == 'VIDE' and p[-1][-6:] == '.shtml':
			item(title, url, False)
		else:
			item(title, url)
	xbmcplugin.endOfDirectory(handle)
else:
	url = parse_qs(urlparse(sys.argv[2]).query)['url'][0]
	if url == 'cctv':
		item('CCTV1', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv1', True)
		item('CCTV2', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv2', True)
		item('CCTV3', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv3', True)
		item('CCTV4', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv4', True)
		item('CCTV5', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv5', True)
		item('CCTV6', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv6', True)
		item('CCTV7', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv7', True)
		item('CCTV8', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv8', True)
		item('CCTV9', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctvjilu', True)
		item('CCTV10', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv10', True)
		item('CCTV11', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv11', True)
		item('CCTV12', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv12', True)
		item('CCTV13', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv13', True)
		item('CCTV14', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctvchild', True)
		item('CCTV15', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctv15', True)
		item('CCTV America', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctvamerica', True)
		item('CCTV Europe', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdcctveurope', True)
		xbmcplugin.endOfDirectory(handle)
	elif url == 'wstv':
		item('北京卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdbtv1', True)
		item('东方卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hddongfang', True)
		item('天津卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdtianjin', True)
		item('重庆卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdchongqing', True)
		item('黑龙江卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdheilongjiang', True)
		item('吉林卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdjilin', True)
		item('辽宁卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdliaoning', True)
		item('内蒙古卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdneimenggu', True)
		item('宁夏卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdningxia', True)
		item('甘肃卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdgansu', True)
		item('青海卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdqinghai', True)
		item('陕西卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdshan3xi', True)
		item('河北卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdhebei', True)
		item('山西卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdshan1xi', True)
		item('山东卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdshandong', True)
		item('安徽卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdanhui', True)
		item('湖北卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdhubei', True)
		item('江西卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdjiangxi', True)
		item('东南卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hddongnan', True)
		item('广东卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdguangdong', True)
		item('深圳卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdshenzhen', True)
		item('广西卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdguangxi', True)
		item('云南卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdyunnan', True)
		item('贵州卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdguizhou', True)
		item('四川卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdsichuan', True)
		item('新疆卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdxinjiang', True)
		item('西藏卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdxizang', True)
		item('旅游卫视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdtravel', True)
		item('北京文艺', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdbtv2', True)
		item('北京科教', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdbtv3', True)
		item('北京影视', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdbtv4', True)
		item('北京财经', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdbtv5', True)
		item('北京体育', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdbtv6', True)
		item('北京生活', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdbtv7', True)
		item('北京青年', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdbtv8', True)
		item('北京新闻', 'http://vdn.live.cntv.cn/api2/live.do?channel=pa://cctv_p2p_hdbtv9', True)
		xbmcplugin.endOfDirectory(handle)
	else:
		o = urlparse(url)
		p = o.path.split('/')
		q = parse_qs(o.query)
		l = len(p)
		if o.netloc == 'tv.cctv.com':
			if l == 5 and p[-2] == 'videoset' and (p[-1] == '' or p[-1] == 'index.shtml'):
				ret = cntv.videoset(url)
				if ret['success'] == False:
					xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
				else:
					for elem in ret['item']:
						item(elem['title'], elem['url'], elem['folder'])
					xbmcplugin.endOfDirectory(handle)
			if p[-1][:4] == 'VIDE' and p[-1][-6:] == '.shtml':
				ret = cntv.play(url)
				if ret['success'] == False:
					xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
				else:
					play(ret['title'], 'stack://' + ' , '.join(ret['url']))
		if o.netloc == 'api.cntv.cn':
			ret = cntv.videolist(url)
			if ret['success'] == False:
				xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
			else:
				for elem in ret['item']:
					item(elem['title'], elem['url'], elem['folder'])
				xbmcplugin.endOfDirectory(handle)
		if o.netloc == 'vdn.live.cntv.cn':
			ret = cntv.live(url)
			if ret['success'] == False:
				xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
			else:
				for elem in ret['item']:
					item(elem['title'], elem['url'], False)
				xbmcplugin.endOfDirectory(handle)
		if 'cntv.cdnpe.com' in o.netloc:
			play('', url)
